﻿<%@ Language="VBScript" codepage=65001 %>
<% Option Explicit %>
<!-- 基本ヘッダー
     #include file="benvelop.inc" -->
<%
Dim bobj,mfile,a,b,fname,i,envelopbox,envelop,rc,fpath,msg
Dim objTextStream,objFileSys,lines,ftype,status,statusfile
Dim objWriteStream,objRegExp,line,mailto,csv,errcnt
Dim objADO,IsExcel,Driver,objRS,IsError,wk
Dim sheetname,colpos,sqlstr,company_name,person_name
Set bobj = Server.CreateObject("basp21pro")
bobj.Env = BASP21_ENV
a = Request.TotalBytes
b = Request.BinaryRead(a)
mfile = bobj.FormFileName(b,"file001",5)
If Len(mfile) > 0 Then
  Set objFileSys = Server.CreateObject("Scripting.FileSystemObject")
  fname = GetBaseName(mfile)
  envelop = bobj.Form(b,"envelop",5)
  envelopbox = bobj.Form(b,"envelopbox",5)
  ftype = bobj.Form(b,"ftype")
  fpath = envelopbox & "\" & envelop & "\" & fname
  rc = bobj.FormSaveAs(b,"file001",fpath)
  msg = bobj.LastMsg
  lines = "":IsError = False
  If rc > 0 Then
    statusfile = envelopbox & "\" & envelop & STATUS_FILE
    Set objTextStream = objFileSys.OpenTextFile(statusfile, ForReading)
    status = Split(objTextStream.ReadAll,vbcrlf)
    objTextStream.Close
    Set objTextStream = Nothing
    If ftype = "mailto" Then
      If status(ST_COL_POS) = "" Then status(ST_COL_POS)="1,2,3"
      colpos = Split(status(ST_COL_POS),",")
      IsExcel = False
      If InStr(fpath,".xls") > 0 Then
        IsExcel = True
        If status(ST_EXCEL_SHEETNAME) = "" Then status(ST_EXCEL_SHEETNAME) = "Sheet1"
        sheetname = status(ST_EXCEL_SHEETNAME)
        On Error Resume Next
        Set objADO = Server.CreateObject("ADODB.Connection")
        Driver=Replace(EXCELDRIVER,"%s",fpath)
        objADO.Open Driver
        If Err<>0 Then
           IsError = True
           msg = Err.Number & " : " & Err.Description & " : " & Driver
        Else
           sqlstr = "select * from [" & sheetname & "$]"
           Set objRS = objADO.Execute(sqlstr)
           If Err<>0 Then
             IsError = True
             msg = Err.Number & " : " & Err.Description  & " : " & sqlstr
           End If
        End If
      Else
        Set objTextStream = objFileSys.OpenTextFile(fpath, ForReading)
      End If
      errcnt = 0
      Set objRegExp = New RegExp
      With objRegExp
        .Pattern = "^\S+@\S+\.\S+$"
        .Global = True             
        .IgnoreCase = True         
      End With
      status(ST_MAILTO_CSV_FILE) = fname
      i = 0
      If IsExcel Then
        csv = vbtab
      Else
        line = objTextStream.ReadLine ' ヘッダ
        If Instr(line,vbtab) > 0 Then
          csv = vbtab
         Else
          csv = ","
         End If
      End If
      Do While Not IsError
        If IsExcel Then
           If objRS.Eof = True Then Exit Do
           line = objRS.Fields(colpos(0)-1).value & vbtab & _
                  objRS.Fields(colpos(1)-1).value & vbtab & _
                  objRS.Fields(colpos(2)-1).value 
           objRS.MoveNext
        Else 
          If objTextStream.AtEndOfStream = True Then Exit Do
          line = objTextStream.ReadLine
          wk = Split(line,csv)
          If UBound(wk) >= colpos(2)-1 Then
            company_name = wk(colpos(0)-1)
            person_name = wk(colpos(1)-1)
            mailto = wk(colpos(2)-1)
            line = company_name & csv & person_name & csv & mailto
          end if
        End If
        i = i + 1
        wk = split(line,csv)
        If UBound(wk) > 1 Then
          mailto = wk(2)
          If objRegExp.Test(mailto) = True Then  ' メールアドレス形式チェック
            lines = lines & i & vbtab & line & vbcrlf
          Else
            lines = lines & i & vbtab & "#span#" & line & "#/span#" & vbcrlf
            errcnt = errcnt + 1 
          End If
        Else
          lines = lines & i & vbtab & "#span#" & line & "#/span" & vbcrlf
          errcnt = errcnt + 1 
        End If
      Loop
      status(ST_MAIL_COUNT) = i
      lines = i & "件読込み"  & vbcrlf & lines
      If errcnt > 0 Then msg = errcnt & "件のエラーがあります"
      If IsExcel Then
        objRS.Close
        objADO.Close
        Set objADO = Nothing
      Else
        objTextStream.Close
        Set objTextStream = Nothing
      End If 
    ElseIf ftype = "body" Then
      Set objTextStream = objFileSys.OpenTextFile(fpath, ForReading)
      status(ST_BODY_FILE) = fname
      lines = objTextStream.ReadAll
      objTextStream.Close
      Set objTextStream = Nothing
    Else
       status(ST_ATTACH_FILE) = fname
      lines = "添付ファイル" 
    End If
    Set objWriteStream = objFileSys.OpenTextFile(statusfile, ForWriting, True)
    objWriteStream.Write Join(status,vbcrlf)
    objWriteStream.Close
    Set objWriteStream = Nothing
    lines = Server.HTMLEncode(lines)
    lines = replace(lines,"#span#","<span style='color:#ff0000;'>")
    lines = replace(lines,"#/span#","</span>")
  End If
  Set objFileSys = Nothing
Else
  msg = "ファイルが選択されていません"
End If
set bobj = Nothing
'
Function GetBaseName(name)
 Dim i
 i = Instrrev(name,"\")
 If i > 0 Then     
   GetBaseName = Mid(name,i+1)
 Else
   GetBaseName = name
 End If
End Function
    
%>
<html><head>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title><%= envelop %> file upload</title>
</HEAD>
<body>
<form>
<input type="button" value="クローズ" onClick="window.opener.location.reload();window.close();">
</form>     
File Name: <%=fpath %><br />
File Size: <%=rc %><br />
<span style="color:#ff0000;"><%= Server.HTMLEncode(msg) %></span>
<PRE style="border: 1px solid gray;background-color: #FDF8F0;white-space: pre;width: 100%;">
<%= lines %>
</PRE>
</body></html>
